/* 
  Beschreibung:     Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                    Beispiel fr Bit- und Byte-IO
								
  Autor:            Rolf Rahm
  Datum:            13.12.2014
  Letzte nderung:  06.10.2015
  Hinweise:	        Beim 8051 knnen sfr nur direkt adressiert werden. Daher knnen 
                    Portregister grundstzlich nicht als Pointer bergeben werden.
                    falsch:  byte_init(P1,IN);
                    richtig: byte_init(PORT1,IN);
*/
#include "controller.h"

#define	LED8					PORT0
#define	DipSchalter8 	PORT1

void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(DipSchalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
  
  bit_init(PORT3,7,IN);            // P3.2 = Taster
  bit_init(PORT2,0,OUT);           // LED
}

// Funktion main()
void main(void)
{
  uint8_t temp;
  
  setup();

  while(1)                          // Endlosschleife loop()
  {	
    // Byte-Operationen
    temp = byte_read(DipSchalter8);
    byte_write(LED8,~temp);
    
    // Bit-Operationen:
    temp = bit_read(PORT3,7);       // temp = P3.7;
    bit_write(PORT2,0,~temp);       // P2.0 = temp;
  }
}