/* 
  Beschreibung:     Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                    Vorschlag fr AD-Umsetzer
                    Das Programm liest einen Analogwert ein und zeigt ihen am LCD an.
  Bibliotheken:     in_out.c
                    communication.c    (ADC wird ber I2C angeschlossen)
	                  delay.c
	                  lcd.c
  Autor:            Rolf Rahm
  Datum:            18.02.2015
  Letzte nderung:  30.09.2015
*/
#include "controller.h"

// Funktionen
void setup (void)
{
	/* Initialisierungen */
	lcd_init();
	adc_init();

	lcd_clear();
	lcd_setcursor(1,1);
	lcd_print("ADC Test");
}

// Funktion main()
void main(void) 
{
	uint8_t buf;
  uint8_t blink;
	
	setup();
	
	while(1)						// Endlosschleife loop()
	{	
		buf = adc_in1();
		lcd_setcursor(2,2);
		lcd_byte(buf);
    if(blink) 
    {
      lcd_print("   *");
      blink = 0;
    }
    else      
    {
      lcd_print("    ");
      blink = 1;
    }
      
		delay_ms(500);
	}
}
