/* 
  Beschreibung:     Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                    Beispiel fr externen Interrupt
                    Hinweis: Standardmssig ist dies der externe Interrupt 0 (Port 3.2)
								
  Autor:            Rolf Rahm
  Datum:            18.02.2015
  Letzte nderung:  26.10.2015
*/

#include "controller.h"

uint8_t i = 0;

// Funktionen
void setup (void)
{
	/* Initialisierungen */
  lcd_init();
  ext_interrupt_init( ext_interrupt_isr );
  
  lcd_clear();
  lcd_setcursor(1,1);
  lcd_print("Int Test");
  
  ext_interrupt_enable();     // Interrupt freigeben
}

// Interrupt-Serviceroutine
// Die Funktion ext_interrupt_isr() wird bei fallender Flanke an P3.2 aufgerufen!
// Funktionskopf (Name) darf nicht gendert werden!!!
void ext_interrupt_isr(void)
{
  delay_ms(40);               // Taster-Entprellung
  i++;
}

// Funktion main()
void main(void)
{
  //uint8_t n;
	
  setup();
	
  while(1)                    // Endlosschleife
  {
    lcd_setcursor(2,4);       // Anzahl der Interrupts anzeigen
    lcd_int(i);
    
    lcd_setcursor(2,1);       // Aktivittsanzeige
    lcd_char('*');
    delay_ms(500);
    lcd_setcursor(2,1);
    lcd_char(' ');
    delay_ms(500);
  }
}
