// Technische Richtlinie FA205 
// Bibliothek:       communication.h
// Controller:       8051
// Version:          1.0
// erstellt am:      30.9.2015
// letzte nderung:  02.10.2015
// Autor:            Rahm

#ifndef _COMMUNICATION_H_
#define _COMMUNICATION_H_

#include "controller.h"

//*************************************************************
//Globale Definitionen
// ... fr I2C-Funktionen
#define I2C_PORT P4
#define SDA  1       // Bit P4.1
#define SCL  0       // Bit P4.0

#define ACK  0
#define NACK 1

// ... fr RS232-Funktionen
#define BAUD 9600

//*************************************************************
// Funktionsprototypen fr I2C-Busschnittstelle (Master-Mode)
extern void    i2c_init    ( void );
extern void    i2c_start   ( void );
extern void    i2c_stop    ( void );
extern uint8_t i2c_write   ( uint8_t value);     // Rckgabewert ACK / NACK
extern uint8_t i2c_read    ( uint8_t ack );      // Rckgabewert Value

// Funktionsprototypen fr RS232-Schnittstelle
extern void    rs232_init  ( void );
extern uint8_t rs232_get   ( void );
extern void    rs232_put   ( uint8_t value );
extern void    rs232_print ( uint8_t text[] );

#endif
