// Technische Richtlinie FA205 
// Bibliothek:       in_out.h
// Controller:       8051
// Version:          1.0
// erstellt am:      30.9.2015
// letzte nderung:  02.10.2015
// Autor:            Rahm

#ifndef _IN_OUT_H_
#define _IN_OUT_H_

#include "controller.h"

//*******************************************************************************
// Globale Schalter und Symbole
// ... fr Bit- und Byte-I/O
//#define NOPULLUPS					// Bei manchen Controllern knnen die Pulluops abgeschaltet werden (z.B. at89cxx)
#define IN  0
#define OUT 1
// Namen (Aliase) fr Ports
enum ports {PORT0,PORT1,PORT2,PORT3};  // PORT0 = 0, PORT1 = 1, .... (8051)

// ... fr PWM (at89c5131)
#define PWM_PIN 7           //      3,4,5,6,7 -> P1.3, ..., P1.7

// ... fr ADC (der At89C5131 hat keinen eigenen ADC.) Daher werden I2C-ICs
//     verwendet. Es darf immer nur ein Schalter aktiviert sein!
#define _ADC081C021_        // Schalter fr adc081c021
//#define _PCF8591_           // Schalter fr PCF8591

//*******************************************************************************
// Funktionsprototypen fr Bit- und Byte Ein-/Ausgabe
extern void    bit_init   ( uint8_t port, uint8_t bitnr, uint8_t direction);
extern uint8_t bit_read   ( uint8_t port, uint8_t bitnr);
extern void    bit_write  ( uint8_t port, uint8_t bitnr, uint8_t value);

extern void    byte_init  ( uint8_t port, uint8_t direction);
extern uint8_t byte_read  ( uint8_t port );
extern void    byte_write ( uint8_t port, uint8_t value);

// Funktionsprototypen fr PWM
extern void    pwm_init   ( void );
extern void    pwm_start  ( void );
extern void    pwm_stop   ( void );
extern void    pwm_duty_cycle ( uint8_t value);

// Funktionsprototypen fr AD-Wandler
extern void    adc_init   ( void );
extern uint8_t adc_in1    ( void );
extern uint8_t adc_in2    ( void );

#endif