/********************************************************************************
|  CLASS:     	8051er
|  Compiler:	KeiluV3
|  PROGRAM:     LLichtT0_b1.c   
|  AUTHOR:     	Gerhard Neumaier
|  DATE:       	Jan2010
|  DESCRIPTION: ein Lauflicht am Port2,Werte kommen aus einem Array (Tabelle),
				Zeitverzoegerung mit Timer0
|			
|  REQUIREMENTS: 8051er z.B. ATMEL89S8253 oder ATMEL89C5131 am Port 2 8xLEDs
|  NOTES:         Ein komplettes Programm, keine Aenderungen notwendig
|  Aufgaben:	  Geschwindigkeit aendern, Ausgabewerte aendern, Timer ndern
|  REVISION HISTORY:
| 
********************************************************************************/
/*-------------------------------------------------------------------------------
  HEADER FILES
-------------------------------------------------------------------------------*/
#include <REG8253.H>   // Processor header file
               
/*-------------------------------------------------------------------------------
  PROGRAM CONSTANTS
-------------------------------------------------------------------------------*/
#define PORT2  P2	//P2 lautet nun PORT2

/*-------------------------------------------------------------------------------
  VARIABLE DECLARATIONS GLOBAL
-------------------------------------------------------------------------------*/
	char i; //Definition der benutzten Variablen char= min -128 bis max +127  (8bit)
code unsigned char const Llicht[] = {0x01,0x03,0x07,0x0f,0x1f,0x3f,0x7f,0xff}; //Array mit 8 Werte
								//Fuer das lauflicht
/*-------------------------------------------------------------------------------
  FUNCTION PROTOTYPES
-------------------------------------------------------------------------------*/
void timer(void);
void Timer0nachladen();
void init()
{
	//Hier wird die Konfiguration von Timer 0 festgelegt				  
	TMOD = 0x01;	//Timer0 im Modus2 16bit Zaehler
	TCON = 0x11;	//Start Zaehler0 
 	Timer0nachladen();
	//Interrupt Timer0 freigeben
	ET0 = 1;		//Interrupt Timer0 freigeben
	EA = 1;			//Globale Interruptfreigabe

}
void Timer0nachladen()	   //Funktion
{
	TL0 = 0x17;		//Timer0 wieder mit 64535dez laden = FC17 hex
	TH0 = 0xFC;		 //65535-1000= 64535   somit sind nur 1000 Impulse notwendig bis Timer0
					 //berluft (bei 65535) und dann einen INT auslst.
					 //Bei fQuarz =12 MHz dauert ein Impuls 1 sec
}

/*===============================================================================
  FUNCTION:     main()
  DESCRIPTION:  Festlegen der notwendigen Interrupt Freigabe-bits im Reg TMOD und TCON
  				sowie INT Freigabe und Vorladen Timer0. Das alles steht in der init-Funktion
				Danach eine Endlosschleife ohne eine Funktion -> while(1)
				An PORT2 (P2) ein Lauflicht
===============================================================================*/
void main(void)
{
	init();
												
	while (1)		// Endlosschleife, jeder uC arbeitet ohne Ende, also Endlosschleife													
					//Die Bedingung while (1) ist naemlich immer erfuellt
	{
	//Es gibt hier nichts zu tun alles findet in der interruptroutine statt
	}		//Ende while
}			//Ende main



/*===============================================================================
  FUNCTION:     interrupt Timer0()     Begriff Timer0 beliebig, interrupt ist zwingend
	Hinweis: Die Haeufigkeit des Aufrufs haengt von fquarz ab!!	  */

//Begin Interruptroutine Timer0 oder ISR(Interrupt Service Routine) Timer0
void timer(void) interrupt 1		//Programmbeginn an Adresse 000Bh Interruptnr.:1
					//Dieser Programmteil wird immer nach einer msec aufgerufen bei 
{					//Ueberlauf von Timer0

	int count;	
	count++;		//Diese Variable wird jedesmal um 1 erhht
	if(count==1000)	//Dieser Programmteil wird somit jede Sekunde ausgefhrt
	{				   //Hinweis: Fr ganz genaue Zeit muss die Durchfhrung der ISR mit
	count=0;		   //bercksichtigt werden.
	PORT2 = Llicht[i]; 	//Ausgabe an  PORT2
	i=i+1;
	if(i==8)
		{
		i=0;
		}
	}
	Timer0nachladen();  //Aufruf Funktion
}
		
 
