 /********************************************************************************
|  CLASS:     	8051er 
|  Compiler:	KeiluV3
|  PROGRAM:     Treiber_Seg73stellig.c   
|  AUTHOR:     	Gerhard Neumaier
|  DATE:       	7.April. 2013
|  DESCRIPTION: bergabewert x0_999 wird in der Funktion dual_HZE zerlegt in H, Z, Einer
|			 diese Werte werden dann nacheinander auf die 7 Seg Anzeige gegeben.
			Die Angabe, welche Segmente leuchten sind in dem Array	 seg7code[] hinterlegt
|  REQUIREMENTS:  Am Portpin3.2 Impulse (Rechteckgenerator oder Taster)
		gemultiplexte 7Seg Anzeige am Port 2 und Port 1 ->siehe define
|  NOTES:         Ein komplettes Programm, keine Aenderungen notwendig
|  Aufgaben:	Geschwindigkeit aendern, Ausgabewerte aendern, Port aendern
|  REVISION HISTORY:   Januar 2010, ATMEL89S8253 oder ATMEL 89C5131 USB C
| 
********************************************************************************/

#include <at89c5131.h>
		
/* benutzt wird 4x7Seg.-Anzeige Gewerbl_Schulen_Offenburg  
   Hier werden die Pins und der Port fr die gemultiplexte 7Seg Anzeige definiert: */
	#define	pin_einer		P1_0		//Auswahl der 7Seg Anzeige low aktiv
	#define	pin_zehner		P1_1
	#define	pin_hunderter	P1_2
    #define	port7seg_data	P2		   //Daten fr die Segmente der Anzeige
//Bitkombinationen fr 7-Segment-Anzeigen (7-Segment-Code)
unsigned char seg7code[] = {0x3F,0x06,0x5B,0x4f,0x66,0x6D,0x7D, 0x07,0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71}; 	
unsigned char einer =0, zehner =0, hundert = 0;	

 void zeit (unsigned int z_wert);
void dual_HZE (unsigned int dualzahl);
//Hier die Funktion des 7Seg Treibers:
void Treiber_Seg73stellig (int x0_999)
 {
	dual_HZE(x0_999);	
			 
			pin_hunderter = 1;	// Hunderter  Anzeige sperren
			pin_zehner = 1;	// Zehner Anzeige sperren
			pin_einer = 0;	// Einer Anzeige freigeben 
			port7seg_data = seg7code[einer];							
			zeit (2000);	//mit grerer Verzgerung wird der Multiplexeffekt sichtbar

			pin_hunderter = 1;	// Hunderter  Anzeige sperren
			pin_zehner = 0;	// Zehner Anzeige freigeben
			pin_einer = 1;	// Einer Anzeige sperren Portpin 1_0
			port7seg_data = seg7code[zehner];							
			zeit (2000);			

			pin_hunderter = 0;	// Hunderter  Anzeige freigeben
			pin_zehner = 1;	// Zehner Anzeige sperren
			pin_einer = 1;	// Einer Anzeige sperren Portpin 1_0
			port7seg_data = seg7code[hundert];						
			zeit (2000);				
		
}
 void zeit (unsigned int z_wert)
{	unsigned int z;				 
   for (z= z_wert; z != 0; z--) {;}	
}    
 // Zerlegung des bergabewertes in H Z und E   
void dual_HZE (unsigned int dualzahl)	
{							   //z.B. dualzahl =485
	hundert=dualzahl/100;		   //hundert = 4
	 dualzahl = dualzahl-(hundert*100); //485-400=85					
	zehner = dualzahl/10;		//85/10 =8
	 dualzahl = dualzahl-(zehner*10); 	//85-80 = 5	
	einer = dualzahl;			 //einer=5
}