 /********************************************************************************
|  CLASS:     	8051er 
|  Compiler:	KeiluV3
|  PROGRAM:     Treiber_Seg73stellig.c   
|  AUTHOR:     	Gerhard Neumaier
|  DATE:       	7. Maerz 2017
|  DESCRIPTION: bergabewert x0_9999 wird in der Funktion dual_THZE zerlegt
			  	Ein Array mit dem Namen buf wird mit ASCII Zeichen beschrieben
				Bei Zahlen wird 48 hinzuaddiert. Bsp: ASCII fr 0 ist 48 fr 1 ASCII=49 usw
				soll eine 1 erscheinen muss 49 ausgegeben werden.   Alles klar?
				Buchstaben werden in C direct in ASCII umgerechnet mit der Angabe z.B.:  'A'
				Am Ende der Zeichenkette muss eine 0 folgen ->Null terminierter String
|  REQUIREMENTS:  Am Port0 ein LC-Display
	
|  NOTES:         Ein komplettes Programm, keine Aenderungen notwendig
|  Aufgaben:	Geschwindigkeit des Zhlers ndern ->0,1 sec, 1 sec aendern,
                
|  REVISION HISTORY:   Januar 2010, ATMEL89S8253 oder ATMEL 89C5131 USB C
| 					   7. Maerz 2017
********************************************************************************/


		
// benutzt wird ein LC-Display als Anzeige der Gewerbl_Schulen_Offenburg  

#include "Definitionen.h"	  //include Dateien, Bekanntgabe benutzte Funktionen usw.


void Dual_Dez4stellig (int dualzahl);
	unsigned char einer =0, zehner =0, hundert = 0, tausend=0;
	unsigned char buf [12];
//Hier die Funktion des 7Seg Treibers:
void Treiber_LCD4stellig  (int x0_9999)
 {	
   	Dual_Dez4stellig (x0_9999);	  //Funktionsaufruf mit Uebergabewert 
	tausend =tausend+48;	  //hier werden die Werte fr die Stellen der Zahl
	hundert = hundert+48;	  //in ASCII Zeichen umgewandelt.
	zehner = zehner+48;		//48 entspricht ASCII der Null, 49 ist die 1, 50 ist die 2 usw.
	einer = einer+48;
	buf[0]='W';		 		// Buchstabe ASCIICode
	buf[1]='e';
	buf[2]='r';
	buf[3]='t';
	buf[4]='=';
	buf[5]=' ';
	buf[6]=tausend;		
	buf[7]=hundert;
	buf[8]=zehner;
	buf[9]=einer;
	buf[10]='\0';		  //Wichtig: Der Abschluss des Arrays buf muss eine 0 sein keine ASCII '0'
						 //  0terminierter String

 	textlcd (buf,2);	//Inhalt vom Array buf wird in Zeile 2 ausgegeben	->lcd_help.c		
	}	


// ****** Funktion Umsetzer dualzahl ->1000 100 10 1 Stellen wandeln**********
	
//unsigned char einer =0, zehner =0, hundert = 0, tausend=0;	//Variablen enthalten keine Kommazahlen!! Wert 0-255
void Dual_Dez4stellig (int dualzahl)

{
	tausend=dualzahl/1000;		//z.B. dualzahl 3456    dann tausend=3
		dualzahl = dualzahl-(tausend*1000);	//Von Dualzahl wird der volle Tausenderwert abgezogen									//somit nur noch Hunderterwert in Dualzahl.
	hundert=dualzahl/100;		 //z.B. dualzahl nun 456    dann hundert=4
		dualzahl = dualzahl-(hundert*100);	//Von Dualzahl wird der volle Hunderterwert abgezogen							//somit nur noch Zehnerwert in Dualzahl.
	zehner = dualzahl/10;		  //z.B. dualzahl nun 56    dann zehner=5
		dualzahl = dualzahl-(zehner*10);	//Von Dualzahl wird der volle Zehnerwert abgezogen
	einer = dualzahl;			  //z.B. dualzahl nun 6    dann einer=6
 }
 

