/* 
  Beschreibung:     Testprogramm zur Umsetzung der Technischen Richtlinie FA205 fr 8051
                    Beispiel fr LCD
								
  Autor:            G. Neumaier		  Proj: LCD_Test3
  Datum:            24.12.2016
  Letzte nderung:  24.12.2016	G. Neumaier
  lcd.h :Pinbelegung auf Miniboard gendert passend zu LCDHardware Offenburg
  -> Port2 wird eingelesen.	 Zur Kontrolle an PORT1 ausgegeben. AM PORT0 LCDisplay
  -> dort wird   Text ausgegeben und der Wert vom PORT2 als Zahl 0..255
  Aufgaben:  Den Wert von Port2 mit anderer Prog-Variante ausgeben, ohne lcd_print(buf);
*/
#include "controller.h"

#define	LED8	PORT1
#define	Schalter8 	PORT2

//Variablendeclaration global:
code uint8_t text1 [] = "LCD Test GTS OG";	//Array mit Text
	//mit dem Vorsatz code wird das array nicht im internen RAM (ziemlich klein)
	//sondern im Code Speicher(FLASH) untergebracht
uint8_t buf [16];	   //Array anlegen
uint8_t einer =0, zehner =0, hundert = 0, tausend=0;
void setup (void)
{
  /* Initialisierungen Port */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
  /* Initialisierungen LCD */
  lcd_init(); 
  lcd_clear();
}
//Declaration (Bekanntgabe) benutzter Funktionen
void Dual_Dez4stellig (uint16_t dualzahl);

// Funktion main()
int main(void)
{ uint8_t x;
  setup();

  while(1)
  {
    x = byte_read(Schalter8);
    byte_write(LED8,x);

	Dual_Dez4stellig (x);	  //Funktionsaufruf mit Uebergabewert 
	tausend =tausend+48;	  //hier werden die Werte fr die Stellen der Zahl
	hundert = hundert+48;	  //in ASCII Zeichen umgewandelt.
	zehner = zehner+48;		//48 entspricht ASCII der Null, 49 ist die 1, 50 ist die 2 usw.
	einer = einer+48;
	buf[0]='W';		 		// Buchstabe ASCIICode
	buf[1]='e';
	buf[2]='r';
	buf[3]='t';
	buf[4]='=';
	buf[5]=' ';
	buf[6]=' ';		//hier kann man tausend eintragen, wenn die Zahl groesser 999 wird
	buf[7]=hundert;
	buf[8]=zehner;
	buf[9]=einer;
	buf[10]='\0';		  //Wichtig: Der Abschluss des Arrays buf muss eine 0 sein keine ASCII '0'
						//  0terminierter String!

	   //Ausgabe auf LCDisplay
	   lcd_setcursor(1,1);	//linie spalte   column row
	   lcd_print(text1); 

	   lcd_setcursor(2,1);	//linie spalte   column row
	   lcd_print(buf);
  }
}
// ****** Funktion Umsetzer dualzahl ->1000 100 10 1 Stellen wandeln**********
	
//unsigned char einer =0, zehner =0, hundert = 0, tausend=0;	//Variablen enthalten keine Kommazahlen!! Wert 0-255
void Dual_Dez4stellig (uint16_t dualzahl)
{
	tausend=dualzahl/1000;		//z.B. dualzahl 3456    dann tausend=3
		dualzahl = dualzahl-(tausend*1000);	//Von Dualzahl wird der volle Tausenderwert abgezogen									//somit nur noch Hunderterwert in Dualzahl.
	hundert=dualzahl/100;		 //z.B. dualzahl nun 456    dann hundert=4
		dualzahl = dualzahl-(hundert*100);	//Von Dualzahl wird der volle Hunderterwert abgezogen							//somit nur noch Zehnerwert in Dualzahl.
	zehner = dualzahl/10;		  //z.B. dualzahl nun 56    dann zehner=5
		dualzahl = dualzahl-(zehner*10);	//Von Dualzahl wird der volle Zehnerwert abgezogen
	einer = dualzahl;			  //z.B. dualzahl nun 6    dann einer=6
 }
