/********************************************************************************
|  CLASS:     	8051er 
|  Compiler:	KeiluV3
|  PROGRAM:     Lauflicht_array3.c   
|  AUTHOR:     	Gerhard Neumaier
|  DATE:       	7.Jan. 2010
|  DESCRIPTION: Ein Lauflicht am Port2 erzeugen
|
|  REQUIREMENTS:  Am Port2 8LEDs
|  NOTES:         Ein komplettes Programm, keine Aenderungen notwendig
|  Aufgaben:	Geschwindigkeit aendern, Ausgabewerte aendern, Port aendern
|  REVISION HISTORY:   Januar 2010, ATMEL89S8253 oder ATMEL 89C5131 USB C
| 
********************************************************************************/

/*-------------------------------------------------------------------------------
  HEADER FILES
-------------------------------------------------------------------------------*/
#include <at89c5131.h>

/*-------------------------------------------------------------------------------
  PROGRAM CONSTANTS
-------------------------------------------------------------------------------*/
#define leds P2  //Port2 mit leds definieren

/*-------------------------------------------------------------------------------
  VARIABLE DECLARATIONS GLOBAL		 Tabellen (arrays)
-------------------------------------------------------------------------------*/
code	unsigned char LLicht[] = {0x01,0x03,0x07,0x0f,0x1f, 0x3f, 0x7f, 0xff};	 //Tab LLicht
code    unsigned char zeit[] = {250, 220, 190, 160, 130, 100, 70, 40};	//Tab Zeit
//code: Tabelle wird im code-Speicher->Programmspeicher abgespeichert. Wenn eine Tabelle nicht
//verndert wird ist das zu empfehlen -> RAM Speicher wird geschont
//das Programm wird krzer!
	unsigned char n;   //8bit 0..255
/*-------------------------------------------------------------------------------
  FUNCTION PROTOTYPES
-------------------------------------------------------------------------------*/
void wait1ms (int ms1);   //Bekanntgabe, dass Funktion ("Unterprogramm") wait1ms vorhanden ist
                    //hier in einer getrennten Datei. Diese Datei muss dem Projekt beigefgt sein
/*===============================================================================
  FUNCTION:     main()
  DESCRIPTION:  PORTC auf Ausgabe schalten, Lauflicht erzeugen
===============================================================================*/
void init(void)   //Steht die Funktion vor main, dann muss die Funktion nicht als Prototyp angemeldet werden.
{
// hier nichts zu tun
}

void main (void)		//Beginn Hauptprogramm
{
  init();
  while (1) 			 				//Beginn Endlosschleife
   {                        
		for (n=0; n<8; ++n)		// Zhler 0 bis 7 												
		{		
		leds = LLicht [n];		 // auf die Werte vom array zugreifen 
      	 wait1ms(zeit[n]);     	// call wait1ms function  Jedes Mal eine anderer Zeitwert vom Array zeit
		} 
  }			//Ende WHILE-Schleife
}			//Ende MAIN-Programm

			//Ende main