/* 
  Beschreibung: Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr Pulsweitenmodulation (PWM)
                Am PWM-Ausgang (P1.7) wird eine PWM erzeugt. 
				Der Tastgrad wird mit demWert 0..255 am PORT2 eingestellt.	 
					
  Autor:            Rolf Rahm
  Datum:            18.02.2015
  Letzte nderung:    Test Neumaier Nov2016
   Aufgaben:  1. Funktionierendes Programm testen und das PWM Signal mit dem Scope aufnehmen und analysieren.
   					-> Siehe beiliegende .docDatei Lsung
             2. Ein RC Glied anschliessen und danach eine Analogspannung abhngig vom Tastgrad erzeugen.
			    -> RC Glied dimensionieren und die Spannung mit dem Scope dokumentieren.
			 3. Die Einstellung des Tastgrades der PWM (Puls/Pausenverhltnis) mit einem AD-Wandler
			    vornehmen. Dieser ist an den mC anzuschliessen ber den IIC-Bus mit dem IC PCF5891
  				Der  AD Wandler ist ein Wandler am IICBus.
				IC: PCF 8591 4fach ADWandler   Basisadresse 0x90	in der 	communication.h eingestellt
				In der communication.h Datei:
				#define I2C_PORT P4
				#define SDA  1       // Bit P4.1
				#define SCL  0       // Bit P4.0
*/
#include "controller.h"
#define	schalter8 	PORT2	//hier 8xSchalter anschliessen->Wert 0...255
// Funktionen
void setup (void)
{
	/* Initialisierungen */
	lcd_init();

	pwm_init();
	bit_init(PORT3,6,IN);           // Dipschalter (P3.6)
  	byte_init(schalter8,IN);
  lcd_clear();
  lcd_setcursor(1,1);
  lcd_print("PWM Test");
}

// Funktion main()
void main(void)
{
  uint16_t temp;

  setup();

  while(1)                        // Endlosschleife
  {
    if (bit_read(PORT3,6) == 1)
    {
      pwm_start();
      lcd_setcursor(2,1);
      lcd_print(" on ");
    }
    else
    {
      pwm_stop();
      lcd_setcursor(2,1);
      lcd_print(" off");
    }
	//temp=10;	 //zumtesten fixer Wert

    temp = byte_read(schalter8);	 //Port 0..255 einlesen
    pwm_duty_cycle((uint8_t)temp);        // PWM Tastgrad ndern
    lcd_setcursor(2,5);
    temp = 100 - temp*100/255;	 //Umrechnung in Prozent
    lcd_byte((uint8_t)temp);
    lcd_char('%');
    delay_ms(500);
  }
}
