/* 
  Beschreibung:	Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr RS232 Sende- und Empfangsroutinen

				Mit Hilfe eines Bluetooth Moduls HC06 wird eine Verbindung zu einem Smartphone aufgebaut
				Das Modul setzte die Signale um in ein serielles Signal 0..5V 9600BAUD8Datenbits noParitiy 1Stoppbit
                Fr das Smartphone gibt es viele Apps, die Bluetooth untersttzen. Eine App mit der Mglichkeit
				die Oberflche selbst zu gestalten nennt sich Keuwl.com. Unter dieser Adresse auch Beispiele fr ARDUINO

				in diesem Beispiel werden jeweils 4 digitale Signale empfangen und gesendet. Somit auf beiden Seiten
				4x LED und 4xSchalter notwendig
				Am uC: Portpin2.0 bis 2.3 Schalter und Portpin1.0 bis 1.3 LEDs

				Vom Handy kommt ein Byte wenn Schalter on groer Buchstabe z.B. E und wenn off kleiner Buchstabe z.B. e
				Vom uC muss ein Farbsignal an das Handy an die entsprechende LED gesendet werden im RGB Format 24bit.
				Dieses Signal muss als eine Zeichenkette gesendet werden.
			    z.B.: uint8_t buf [16]={"*xR255G0B0*"};	  wobei fuer x ein Buchstabe fuer die entsprechende LED eingesetzt werden muss
				Hier wird die Farbe Rot 255 ausgegeben Gruen 0 und Blau 0	somit Farbe reines Rot


			  uC 8051er: Portpin 3.0=  RxD   Portpin 3.1= TxD	  Anbindung Bluetooth_Modul: ModulRxD zu uCTxD 	  ModulTxD zu uCRxD 
																  T=Transmit (senden)  R=Receive(empfangen)

	Hinweis: In den Bibliotheken lcd.c nicht mit eingebunden, ansonsten 2k ueberschritten ->Demoversion Keil streikt im debug-Modus

  Letzte nderung:  29.12.2016	  G. Neumaier    DigitalInOut
*/
#include "controller.h"
#define	LED8	 PORT1
#define	Schalter8 	PORT2


//Declaration (Bekanntgabe) benutzter Funktionen
void Dual_Dez4stellig (uint16_t dualzahl);
uint8_t einer =0, zehner =0, hundert = 0, tausend=0;
uint8_t buf1 [16]={"*xR255G0B0*"};	   //Array anlegen mit ASCIIZeichen 0-terminiert
/*Das gleiche:
	buf1[0]='*';		//ansprechen LED auf Handy mit *a
	buf1[1]='a';	 
	buf1[2]='R';	   	//Farbanweisung in RGB jeweils 8bit ->24bit Farbtiefe
	buf1[3]='2';	  //hier: Rot 255, Gruen 0, Blau 0
	buf1[4]='5';
	buf1[5]='5';	
	buf1[6]='G';
	buf1[7]='0';
	buf1[8]='B';
	buf1[9]='0';
	buf1[10]='*';
	buf1[11]='\0';	 //Null terminierter String
*/
uint8_t buf2 [16]={"*xR0G255B0*"};	   //Array anlegen mit ASCIIZeichen 0-terminiert

// Funktionen
void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
								  //loescht pins
//  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
    bit_init(PORT1,0,OUT);           // LED	
	bit_init(PORT1,1,OUT);           // LED	
    bit_init(PORT1,2,OUT);           // LED	
    bit_init(PORT1,3,OUT);           // LED	

    bit_init(PORT2,0,IN);           // Schalter	
	bit_init(PORT2,1,IN);           // Schalter		
    bit_init(PORT2,2,IN);           // Schalter		
    bit_init(PORT2,3,IN);           // Schalter		
  rs232_init();

  rs232_print("Hallo Welt!\n");			// Zeichenkette senden!
}

// Funktion main()
void main(void)
{
  uint8_t x,ch;	   

  setup();
  
  while(1)   // Endlosschleife
  {
	 //An Bluetooth senden Portpin2.0 bis 2.3  AufHandy:LED0=a LED1=b LED2=c LED3=d
		x= bit_read(PORT2,0); //BitP2.0 einlesen
	  	if(x==0)
		{
	 		// Buchstabe ASCIICode
	    buf2[1] ='a';  //in Zeichenkette statt x a eintragen	 
    	rs232_print(buf2);	// Zeichenkette senden!	 RGBgruen
		}
	   	else	
	   	{
      	buf1[1]	='a';
	    rs232_print(buf1);	// Zeichenkette senden! RGBrot 
	    }

		x= bit_read(PORT2,1);
	  	if(x==0)
	  	{
	  	buf2[1] ='b';	 
      	rs232_print(buf2);	// Zeichenkette senden!	 RGBgruen
	  	}
	   else	
	   {
       buf1[1]	='b';
	   rs232_print(buf1);	// Zeichenkette senden! RGBrot 
	   }

		x= bit_read(PORT2,2);
	  	if(x==0)
	  	{
	  	buf2[1] ='c';	 
      	rs232_print(buf2);	// Zeichenkette senden!	 RGBgruen
	  	}
	   else	
	   {
       buf1[1]	='c';
	   rs232_print(buf1);	// Zeichenkette senden! RGBrot 
	   }

		x= bit_read(PORT2,3);
	  	if(x==0)
	  	{
	  	buf2[1] ='d';	 
      	rs232_print(buf2);	// Zeichenkette senden!	 RGBgruen
	  	}
	   else	
	   {
       buf1[1]	='d';
	   rs232_print(buf1);	// Zeichenkette senden! RGBrot 
	   }



			//Empfangen von der Schnittstelle

		//	  Bluetooth	4Schalterwerte empfangen 1. E on  e	off 2.F on f off usw
		//4pins am PORT1 schalten P1.0 bis P1.3
		 ch=rs232_get();
//	 	 while(ch == '\0') //stoppt hier bis ein Wert empfangen wird
//	    {  //nichts zu tun,  nur warten
//      } //ende while

		 delay_ms(20);
		 //Empfangene zeichen auswerten und dann entsprechend die PortpinsP1.0 bis P1.3 schalten
		if(ch=='E')
		{
		bit_write(PORT1,0,1);	//P1 Pin 1.0 set
		}
		 if(ch=='e')
		{
		bit_write(PORT1,0,0);	 //P1 Pin 1.0 reset
		}
		if(ch=='F')
		{
		bit_write(PORT1,1,1);	 //P1 Pin 1.1 set
		}
		 if(ch=='f')
		{
		bit_write(PORT1,1,0);	 //P1 Pin 1.1 reset
		}
		if(ch=='G')
		{
		bit_write(PORT1,2,1);	 //P1 Pin 1.2 set
		}
		 if(ch=='g')
		{
		bit_write(PORT1,2,0);	 //P1 Pin 1.2 reset
		}
		if(ch=='H')
		{
		bit_write(PORT1,3,1);	//P1 Pin 1.3 set
		}
		 if(ch=='h')
		{
		bit_write(PORT1,3,0);	//P1 Pin 1.3 reset
		}






	  /*


	 if(ch>=0x30 && ch<=0x39) //ASCII Zahlen??	Wert zwischen 0x30(48dez) und 0x39(57dez)
	 {						  //Hinweis:  ASCIIZeichen 0 = 48  ASCIIZeichen 1 = 49  usw
	  
	  //value = (value * 10) + (ch - '0'); // neuer Wert value berechnen
      value = (value * 10) + (ch - 48); //  neuer Wert value berechnen
										//  nur empfangene ASCII-Zahlen sinnvoll
	  }


	  */



	 }
	   								
     /*   //Auch eine Mglichkeit: Der zahl 0..255 wird eine 4 vorgestellt:
	 if (value >= 4000 && value<=4255) //Dem Wert 0..255 wird eine 4 vorgestellt vom Sender
      {								  //Eine Idee von vielen zum Synchronisieren
	   	byte_write(LED8,(value-4000));	  //Bei Ausgabe auf Port nur Zahlen bis 255 sinnvoll
		value=0;
	   }
      if (value>4255) //Zur Sicherheit bei Fehlern
      {								  //Eine Idee von vielen zum Synchronisieren
		value=0;
	   }
	 */
  
 }

// ****** Funktion Umsetzer dualzahl ->1000 100 10 1 Stellen wandeln**********
	
//unsigned char einer =0, zehner =0, hundert = 0, tausend=0;	//Variablen enthalten keine Kommazahlen!! Wert 0-255
void Dual_Dez4stellig (uint16_t dualzahl)
{
	tausend=dualzahl/1000;		//z.B. dualzahl 3456    dann tausend=3
		dualzahl = dualzahl-(tausend*1000);	//Von Dualzahl wird der volle Tausenderwert abgezogen									//somit nur noch Hunderterwert in Dualzahl.
	hundert=dualzahl/100;		 //z.B. dualzahl nun 456    dann hundert=4
		dualzahl = dualzahl-(hundert*100);	//Von Dualzahl wird der volle Hunderterwert abgezogen							//somit nur noch Zehnerwert in Dualzahl.
	zehner = dualzahl/10;		  //z.B. dualzahl nun 56    dann zehner=5
		dualzahl = dualzahl-(zehner*10);	//Von Dualzahl wird der volle Zehnerwert abgezogen
	einer = dualzahl;			  //z.B. dualzahl nun 6    dann einer=6
 }



