/* 
  Beschreibung:	Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr RS232 Sende- und Empfangsroutinen

				Mit Hilfe eines Bluetooth Moduls HC06 wird eine Verbindung zu einem Smartphone aufgebaut
				Das Modul setzte die Signale um in ein serielles Signal 0..5V 9600BAUD8Datenbits noParitiy 1Stoppbit
                Fr das Smartphone gibt es viele Apps, die Bluetooth untersttzen. Eine App mit der Mglichkeit
				die Oberflche selbst zu gestalten nennt sich Keuwl.com. Unter dieser Adresse auch Beispiele fr ARDUINO

				in diesem Beispiel werden 4 digitale Signale empfangen. Somit auf uC Seite 4x LED notwendig. Auf dem Handy 4xSchalter
				Am uC: Portpin1.0 bis 1.3 LEDs

				Vom Handy kommt ein Byte wenn Schalter on groer Buchstabe z.B. E und wenn off kleiner Buchstabe z.B. e

			  uC 8051er: Portpin 3.0=  RxD   Portpin 3.1= TxD	  Anbindung Bluetooth_Modul: 	 ModulTxD zu uC RxD  eine Leitung+GND
																  T=Transmit (senden)  R=Receive(empfangen)

	Hinweis: - In den Bibliotheken lcd.c nicht mit eingebunden, ansonsten 2k ueberschritten ->Demoversion Keil streikt im debug-Modus
			 - Laesst sich gut im Debugger keil simulieren. Dazu unter View-> Serial Window #1 oeffnen und die Buchstaben eingeben. Port1 unter
			   Peripherals sichtbar machen
  Letzte nderung:  29.12.2016	  G. Neumaier    Digital_uCin
*/
#include "controller.h"
#define	LED8	 PORT1
#define	LED8_2	 PORT0
#define	Schalter8 	PORT2


//Declaration (Bekanntgabe) benutzter Funktionen
void Dual_Dez4stellig (uint16_t dualzahl);
uint8_t buf [16];	   //Array anlegen
uint8_t einer =0, zehner =0, hundert = 0, tausend=0;

// Funktionen
void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(LED8_2,OUT); 		  //loescht pins
  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
    bit_init(PORT1,0,OUT);           // LED	
	bit_init(PORT1,1,OUT);           // LED	
    bit_init(PORT1,2,OUT);           // LED	
    bit_init(PORT1,3,OUT);           // LED	
  rs232_init();

  rs232_print("Hallo Welt!\n");	// Zeichenkette senden!
}

// Funktion main()
void main(void)
{
  uint8_t ch;

  setup();
  
  while(1)                            // Endlosschleife
  {

//	  Bluetooth	4Schalterwerte empfangen 1. E on  e	off 2.F on f off usw
		//4pins am PORT1 schalten P1.0 bis P1.3
 	  	 while((ch=rs232_get()) == '\0') //stoppt hier bis ein Wert empfangen wird
		{  //nichts zu tun,  nur warten
	    } //ende while

		if(ch=='E')	  //Erster Schalter auf dem Handydisplay (Keuwl) ON=E  OFF=e
		{
		bit_write(PORT1,0,1);	//P1 Pin 1.0 set
		}
		 if(ch=='e')
		{
		bit_write(PORT1,0,0);				 //P1 Pin 1.0 reset
		}
		if(ch=='F')
		{
		bit_write(PORT1,1,1);				 //P1 Pin 1.1 set
		}
		 if(ch=='f')
		{
		bit_write(PORT1,1,0);				 //P1 Pin 1.1 reset
		}
		if(ch=='G')
		{
		bit_write(PORT1,2,1);				 //P1 Pin 1.2 set
		}
		 if(ch=='g')
		{
		bit_write(PORT1,2,0);				 //P1 Pin 1.2 reset
		}
		if(ch=='H')
		{
		bit_write(PORT1,3,1);				 //P1 Pin 1.3 set
		}
		 if(ch=='h')
		{
		bit_write(PORT1,3,0);				 //P1 Pin 1.3 reset
		}

	 } //Ende while(1)
	   								
 }	//Ende main



