/* 
  Beschreibung:	Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr RS232 Sende- und Empfangsroutinen
              Ausgegeben wird der Wert PORT2 (0..255) als ASCII-Zeichenkette
			  z.B. 125 -> 0x31  0x32  0x 35
			  danach  0x0a   0x 0d Neue Zeile Wagenruecklauf
			  Empfangen von Daten: Es wird gewartet bis ein beliebiges Zeichen empfangen wird.
			  Wenn ein Zeichen empfangen wird wird auch wieder die Port2 info gesendet, sonst nicht.
			  Wird eine  odere mehrere ASCII Zahlen empfangen und das Steuerzeichen hier Buchstabe a,
			  dann wird dieser Zahlenwert  an PORT1 ausgegeben.
			  ->!Der Empfnger, z.B.PC, muss mit dem Senden eines Zeichens die bertragung anstossen!

              Das Programm wurde so abgendert dass da senden und empfangen nicht mehr 
		 gleichzeitig vonstatten geht!!	   Der uC sendet Werte und empfngt dann 3 Byte, erst danach wird wieder gesendet.

	Hinweis: wird nur ein Byte bertragen (put und get), dann ist der Informationsgehalt nur zwischen 0..255.
			 Grere Werte werden als mehrstellige Zahlen im ASCII-Format bertragen, somit auch
			 Kommazahlen mglich.

			  uC 8051er: Portpin 3.0=  RxD   Portpin 3.1= TxD


  Letzte nderung:  27.12.2016	  G. Neumaier    RS232_Test4
*/
#include "controller.h"

#define	LED8_2	 PORT0
#define	Schalter8 	PORT2


//Declaration (Bekanntgabe) benutzter Funktionen
void Dual_Dez4stellig (uint16_t dualzahl);
uint8_t einer =0, zehner =0, hundert = 0, tausend=0;
uint8_t buf [16]={"*xR255G0B0*"};	   //Array anlegen mit ASCIIZeichen 0-terminiert
/*Das gleiche:
	buf[0]='*';		//ansprechen LED auf Handy mit *a
	buf[1]='a';	 
	buf[2]='R';	   	//Farbanweisung in RGB jeweils 8bit ->24bit Farbtiefe
	buf[3]='2';	  //hier: Rot 255, Gruen 0, Blau 0
	buf[4]='5';
	buf[5]='5';	
	buf[6]='G';
	buf[7]='0';
	buf[8]='B';
	buf[9]='0';
	buf[10]='*';
	buf[11]='\0';
*/
uint8_t buf1 [16]={"*xR0G255B0*"};	   //Array anlegen mit ASCIIZeichen 0-terminiert

// Funktionen
void setup (void)
{
  /* Initialisierungen */
//  byte_init(LED8,OUT);         // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(LED8_2,OUT); 		 //loescht pins
  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!

    bit_init(PORT2,0,IN);           // Schalter	
	bit_init(PORT2,1,IN);           // Schalter		
    bit_init(PORT2,2,IN);           // Schalter		
    bit_init(PORT2,3,IN);           // Schalter		
    rs232_init();

    rs232_print("Hallo Welt!\n");			// Zeichenkette senden!
}

// Funktion main()
void main(void)
{
  uint8_t x;

  setup();
  
  while(1)                            // Endlosschleife
  {

	  x=byte_read(Schalter8);	//Einlesen 8 bit und Ausgabe. Hilfreich zum Testen des Programmes
	  byte_write(LED8_2,x);
	 //An Bluetooth senden Portpin2.0 bis 2.3  AufHandy:LED0=a LED1=b LED2=c LED3=d
		x= bit_read(PORT2,0);
	  	if(x==0)
		{
	 		// Buchstabe ASCIICode
	    buf1[1] ='a';  //in Zeichenkette statt x a eintragen	 
    	rs232_print(buf1);	// Zeichenkette senden!	 RGBgruen
		}
	   else	
	   {
       buf[1]	='a';
	   rs232_print(buf);	// Zeichenkette senden! RGBrot 
	   }

	  x= bit_read(PORT2,1);
	  if(x==0)
	  {
	  buf1[1] ='b';	 
      rs232_print(buf1);	// Zeichenkette senden!	 RGBgruen
	  }
	   else	
	   {
       buf[1]	='b';
	   rs232_print(buf);	// Zeichenkette senden! RGBrot 
	   }

 	  x= bit_read(PORT2,2);
	  if(x==0)
	  {
	  buf1[1] ='c';	 
      rs232_print(buf1);	// Zeichenkette senden!	 RGBgruen
	  }
	   else	
	   {
       buf[1]	='c';
	   rs232_print(buf);	// Zeichenkette senden! RGBrot 
	   }

	  x= bit_read(PORT2,3);
	  if(x==0)
	  {
	  buf1[1] ='d';	 
      rs232_print(buf1);	// Zeichenkette senden!	 RGBgruen
	  }
	   else	
	   {
       buf[1]	='d';
	   rs232_print(buf);	// Zeichenkette senden! RGBrot 
	   }

	 }	//Ende while(1)
	   							
  
 }	 //Endemain

