/* 
  Beschreibung:	Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr RS232 Sende- und Empfangsroutinen
              Ausgegeben wird der Wert PORT2 (0..255) als ASCII-Zeichenkette
			  z.B. 125 -> 0x31  0x32  0x 35
			  danach  0x0a   0x 0d Neue Zeile Wagenruecklauf
			  Empfangen von Daten: Es wird gewartet bis ein beliebiges Zeichen empfangen wird.
			  Wenn ein Zeichen empfangen wird wird auch wieder die Port2 info gesendet, sonst nicht.
			  Wird eine  odere mehrere ASCII Zahlen empfangen und das Steuerzeichen hier Buchstabe a,
			  dann wird dieser Zahlenwert  an PORT1 ausgegeben.
			  ->!Der Empfnger, z.B.PC, muss mit dem Senden eines Zeichens die bertragung anstossen!

	Hinweis: wird nur ein Byte bertragen (put und get), dann ist der Informationsgehalt nur zwischen 0..255.
			 Grere Werte werden als mehrstellige Zahlen im ASCII-Format bertragen, somit auch
			 Kommazahlen mglich.


  Letzte nderung:  24.12.2016	  G. Neumaier    RS232_Test3
*/
#include "controller.h"
#define	LED8	 PORT1
#define	LED8_2	 PORT0
#define	Schalter8 	PORT2


//Declaration (Bekanntgabe) benutzter Funktionen
void Dual_Dez4stellig (uint16_t dualzahl);
uint8_t buf [16];	   //Array anlegen
uint8_t einer =0, zehner =0, hundert = 0, tausend=0;

// Funktionen
void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(LED8_2,OUT); 
  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
  	
  rs232_init();

  rs232_print("Hallo Welt!\n");			// Zeichenkette senden!
}

// Funktion main()
void main(void)
{
  uint8_t x,ch;
  uint16_t value;
  uint8_t buf[20];
  setup();
  
  while(1)                            // Endlosschleife
  {

	// Byte-Operationen
    x = byte_read(Schalter8);
	byte_write(LED8_2,x);  //Test des Programmes	   //7458 ist ein Test
	Dual_Dez4stellig (x);	  //Funktionsaufruf mit Uebergabewert 
	tausend =tausend+48;	  //hier werden die Werte fr die Stellen der Zahl
	hundert = hundert+48;	  //in ASCII Zeichen umgewandelt.
	zehner = zehner+48;		//48 entspricht ASCII der Null, 49 ist die 1, 50 ist die 2 usw.
	einer = einer+48;
		
	buf[0]=tausend;	 //Zahlen ASCII Code
	buf[1]=hundert;
	buf[2]=zehner;
	buf[3]=einer;
	buf[4]='\0';		  //Wichtig: Der Abschluss des Arrays buf muss eine 0 sein keine ASCII '0'
	delay_ms(10);					//  0terminierter String!

	//rs232_print("\n");			// Zeichenkette senden!
 	rs232_print(buf);	// Zeichenkette senden!	Als ASCII z.b.: 24 Byte: 0x32 0x34
	rs232_put(10);  //Neue Zeile new line oder:
	//rs232_print("\n"); // Zeichennew line senden!
//	rs232_put(13); 	//Wagenruecklauf  carriage return


	//Empfangen von der Schnittstelle
	 while((ch=rs232_get()) == '\0')
	{	//nix zu tun
	}  // Warten bis Zeichen empfangen!
	 rs232_put(ch);	 //Ausgabe auf Schnittstelle zur Kontrolle
								  //Eine Idee von vielen zum Synchronisieren
	   	byte_write(LED8,ch-1);	  //Bei Ausgabe auf Port nur Zahlen bis 255 sinnvoll
						//I Profilab wird +1 gemacht. Grund: Wenn 0gesendet, alle bits aus,
						//dann hier Endlosschleife, deshalb statt 0..255 1..256
  }
}

// ****** Funktion Umsetzer dualzahl ->1000 100 10 1 Stellen wandeln**********
	
//unsigned char einer =0, zehner =0, hundert = 0, tausend=0;	//Variablen enthalten keine Kommazahlen!! Wert 0-255
void Dual_Dez4stellig (uint16_t dualzahl)
{
	tausend=dualzahl/1000;		//z.B. dualzahl 3456    dann tausend=3
		dualzahl = dualzahl-(tausend*1000);	//Von Dualzahl wird der volle Tausenderwert abgezogen									//somit nur noch Hunderterwert in Dualzahl.
	hundert=dualzahl/100;		 //z.B. dualzahl nun 456    dann hundert=4
		dualzahl = dualzahl-(hundert*100);	//Von Dualzahl wird der volle Hunderterwert abgezogen							//somit nur noch Zehnerwert in Dualzahl.
	zehner = dualzahl/10;		  //z.B. dualzahl nun 56    dann zehner=5
		dualzahl = dualzahl-(zehner*10);	//Von Dualzahl wird der volle Zehnerwert abgezogen
	einer = dualzahl;			  //z.B. dualzahl nun 6    dann einer=6
 }
