/* 
  Beschreibung:	Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr RS232 Senderoutinen
              Ausgegeben wird der Wert PORT2 (0..255) als ASCII-Zeichenkette
			  z.B. 125 -> 0x31  0x32  0x 35
			  danach  0x0a   0x 0d Neue Zeile Wagenruecklauf

  Letzte nderung:  24.12.2016	  G. Neumaier    RS232_Test1
*/
#include "controller.h"
#define	LED8	 PORT1
#define	Schalter8 	PORT2


//Declaration (Bekanntgabe) benutzter Funktionen
void Dual_Dez4stellig (uint16_t dualzahl);
uint8_t buf [16];	   //Array anlegen
uint8_t einer =0, zehner =0, hundert = 0, tausend=0;

// Funktionen
void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
  	
  rs232_init();

  rs232_print("Hallo Welt!\n");			// Zeichenkette senden!
}

// Funktion main()
void main(void)
{
  uint8_t x;
  uint8_t buf[20];
  setup();
  
  while(1)                            // Endlosschleife
  {

	// Byte-Operationen
    x = byte_read(Schalter8);
    byte_write(LED8,x);
							   //7458 ist ein Test
	Dual_Dez4stellig (7458);	  //Funktionsaufruf mit Uebergabewert 
	tausend =tausend+48;	  //hier werden die Werte fr die Stellen der Zahl
	hundert = hundert+48;	  //in ASCII Zeichen umgewandelt.
	zehner = zehner+48;		//48 entspricht ASCII der Null, 49 ist die 1, 50 ist die 2 usw.
	einer = einer+48;
	buf[0]='P';		 		// Buchstabe ASCIICode
	buf[1]='o';
	buf[2]='r';
	buf[3]='t';
	buf[4]='2';
	buf[5]='=';
	buf[6]=' ';		
	buf[7]=tausend;
	buf[8]=hundert;
	buf[9]=zehner;
	buf[10]=einer;
	buf[11]='\0';		  //Wichtig: Der Abschluss des Arrays buf muss eine 0 sein keine ASCII '0'
						//  0terminierter String!



	//rs232_print("\n");			// Zeichenkette senden!
 	rs232_print(buf);	// Zeichenkette senden!	Als ASCII z.b.: 24 Byte: 0x32 0x34
//	rs232_put(128);  
//	rs232_put(x); 
	rs232_put(10);  //Neue Zeile new line
	rs232_put(13); 	//Wagenruecklauf  carriage return
	delay_ms(2000); 

  }
}

// ****** Funktion Umsetzer dualzahl ->1000 100 10 1 Stellen wandeln**********
	
//unsigned char einer =0, zehner =0, hundert = 0, tausend=0;	//Variablen enthalten keine Kommazahlen!! Wert 0-255
void Dual_Dez4stellig (uint16_t dualzahl)
{
	tausend=dualzahl/1000;		//z.B. dualzahl 3456    dann tausend=3
		dualzahl = dualzahl-(tausend*1000);	//Von Dualzahl wird der volle Tausenderwert abgezogen									//somit nur noch Hunderterwert in Dualzahl.
	hundert=dualzahl/100;		 //z.B. dualzahl nun 456    dann hundert=4
		dualzahl = dualzahl-(hundert*100);	//Von Dualzahl wird der volle Hunderterwert abgezogen							//somit nur noch Zehnerwert in Dualzahl.
	zehner = dualzahl/10;		  //z.B. dualzahl nun 56    dann zehner=5
		dualzahl = dualzahl-(zehner*10);	//Von Dualzahl wird der volle Zehnerwert abgezogen
	einer = dualzahl;			  //z.B. dualzahl nun 6    dann einer=6
 }
