/* 
  Beschreibung:	Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                Beispiel fr RS232 Empfangsroutinen
				Variante1:
				Eine Zahlenzeichenkette mit drei ASCII-Zahlen wird empfangen und am Port1 ausgegeben
				Variante2:
				Eine Zahlenzeichenkette mit ASCII-Zahlen wird empfangen und am Port1 ausgegeben
				Es wird ein Trennzeichen der zahlen verwendet. Zustzlich wird berprft 
				ob eine ASCIIZahl empfangen wird
  Letzte nderung:  25.12.2016	  G. Neumaier    RS232_Test2
*/
#include "controller.h"
#define	LED8	 PORT1

// Funktionen
void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  	
  rs232_init();
}

// Funktion main()
void main(void)
{
  uint8_t ch,n;
  uint8_t value;
  setup();
/* //Variante 1   
  while(1)  // Endlosschleife
  {
  	
    while((ch=rs232_get()) == '\0')
	{	//nix zu tun
	}   // Warten bis Zeichen empfangen!
	 rs232_put(ch);
	//value = (value * 10) + (ch - '0'); // neuer Wert value berechnen
    value = (value * 10) + (ch - 48); //  neuer Wert value berechnen
										//  nur empfangene ASCII-Zahlen sinnvoll
									//Bei Ausgabe auf Port nur Zahlen bis 255 sinnvoll
	n++;
	  if(n==3)	  //3Zahlen empfangen
	  {
	    byte_write(LED8,value);
		value=0;
		n=0;
	  }

  }
}
*/

 //*Variante2	 mit Endezeichen der Zahlenkette

   while(1)  // Endlosschleife
  {

    while((ch=rs232_get()) == '\0')
	{	//nix zu tun
	}   // Warten bis Zeichen empfangen!
	 rs232_put(ch);	 //Ausgabe auf Schnittstelle zur Kontrolle
	 if(ch>=0x30 && ch<=0x39) //ASCII Zahlen??	Wert zwischen 0x30(48dez) und 0x39(57dez)
	 {						  //Hinweis:  ASCIIZeichen 0 = 48  ASCIIZeichen 1 = 49  usw
	  //value = (value * 10) + (ch - '0'); // neuer Wert value berechnen
      value = (value * 10) + (ch - 48); //  neuer Wert value berechnen
										//  nur empfangene ASCII-Zahlen sinnvoll
	 }
									
      if (ch == 97) // Newline-Zeichen?  97 kleines a  ASCII Tabelle!  beliebig gewhlt
      {
	   	byte_write(LED8,value);	  //Bei Ausgabe auf Port nur Zahlen bis 255 sinnvoll
		value=0;
	   }
	} //Ende while(1)
}  //Ende main