/* 
  Beschreibung:     Testprogramm zur Umsetzung der Technischen Richtlinie FA205
                    Beispiel fr Bit- und Byte-IO
								
  Autor:            Rolf Rahm
  Datum:            23.12.2016	G.Neumaier
  Letzte nderung:  06.10.2015
  Hinweise:	        Beim 8051 knnen sfr nur direkt adressiert werden. Daher knnen 
                    Portregister grundstzlich nicht als Pointer bergeben werden.
                    falsch:  byte_init(P1,IN);
                    richtig: byte_init(PORT1,IN);
*/
#include "controller.h"	  //Fachvorschriften

#define	LED8		PORT0
#define	Schalter8 	PORT1

void setup (void)
{
  /* Initialisierungen */
  byte_init(LED8,OUT);             // Portinitialisierung ist beim 8051 meistens nicht ntig
  byte_init(Schalter8,IN);      // aber aus Kompatibilittsgrnden mit Technischer Richtlinie!
  
  bit_init(PORT3,2,IN);            // P3.2 = Taster
  bit_init(PORT2,0,OUT);           // LED
}

// Funktion main()
void main(void)
{
  uint8_t temp;		//in controller.h Datei definiert
  
  setup();

  while(1)   // Endlosschleife loop()
  {	
    // Byte-Operationen
    temp = byte_read(Schalter8);
    byte_write(LED8,~temp);	//~invertiert
    
    // Bit-Operationen:
    temp = bit_read(PORT3,2);       // temp = P3.2;
    bit_write(PORT2,0,~temp);       // P2.0 = temp; invertiert
  }
}